<?php
/**

	takeone Google Adsense Plugin by takeone ( http://www.takeone.pe.kr )
	+ intelligence AD insert by KAi ( http://kai.ibbun.net/ )


	var 0.3.1

		+ [##_GoogleAdsense_##] 태그 사용할경우 관리자에서 안보이게 하는 기능 않되던거 수정

	ver 0.30 - 2007/11/26

		+ [##_GoogleAdsense_##] 태그 추가
		+ 본문을 여러개 볼때 한번만 광고 출력


	ver 0.20 - 2007/10/24

		+ 관리자로 로그인했을경우 광고 출력 여부 설정
		+ 사이드 바 광고 추가
		+ 아이콘 변경


	ver 0.10

		+ 본문 상단, 본문상단 박스형태, 하단 광고
 */


//	초기화 함수
function googleAdsense_init() {
	define('PLUGIN_GOOGLE_ADSESNSE_INIT', true);

	$GLOBALS['_gGoogleAdsenseCount'] = 1;
}


/**
 *	[##_GoogleAdsense_##] 태그를 출력해준다.
 *
 */
function showTagGoogleAdsense(&$target) {

	//	설정 정보를 가져온다.
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($GLOBALS['configVal']);

	if (!is_null($data)) {
		$showAdmin = $data['showAdmin'];
		$tagGoogleAdsense = $data['tagGoogleAdsense'];
	}

	//만약 관리자라면 아무것도 보이지 않게 한다.
	if (getBlogId() && getUserId() && $showAdmin == 2) {
		return $target;
	}

	return $tagGoogleAdsense;
}



/**
 *	사이드바에 출력할 방법을 정의해준다.
 *
 */
function showGoogleAdenseAtSideBar($parameter) {

	//	미리보기 상태의 글을 표시한다.
	if (isset($parameter['preview'])) {
		return "Google Adsnse";
	}


	//	설정 정보를 가져온다.
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal(&$GLOBALS['configVal']);

	if (!is_null($data)) {
		$showAdmin = $data['showAdmin'];
		$contentSidebar = $data['contentSidebar'];
	}

	//	만약 관리자라면 아무것도 보이지 않게 한다.
	if (getBlogId() && getUserId() && $showAdmin == 2) {
		return;
	}

/*	$target = '<table cellpadding="0" cellspacing="0" width="100%" class="tl_fx">';
	$target.= '<tr><td align="center">'.$contentSidebar.'</td></tr>';
	$target.= '</table>';
*/

	return $contentSidebar;
}


/**
 *	본문에 삽입하는 광고를 클랙한다.
 *
 */
function takeoneViewPostContent(&$target, $view) {

	//	여러 글을 볼 경우에 표시될 광고 갯수를 제한 하기 위한 초기화
	if (defined('PLUGIN_GOOGLE_ADSESNSE_INIT') === false) {
		googleAdsense_init();
	}

	//	설정 정보를 가져온다.
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal(&$GLOBALS['configVal']);
	$data = array_map('trim', &$data);
	$data['sentenceMinLength']*= 3;//	문자열 비교를 위해.

	if (is_null($data) || !is_array($data) || count($data) === 0) {
		return $target;
	}

	//	만약 관리자라면 아무것도 보이지 않게 한다.
	if (getBlogId() && getUserId() && $data['showAdmin'] == 2) {
		return $target;
	}


	//	상단
	if (!empty($data['contentTop']) && $GLOBALS['_gGoogleAdsenseCount'] <= 3) {
		$contentTop = '<div id="googleAdTop" style="clear:both; position:relative; text-align:center;">'. $data['contentTop'] .'</div>';
		$GLOBALS['_gGoogleAdsenseCount']++;
	}

	//	본문
	if (!empty($data['contentTopBox']) && $GLOBALS['_gGoogleAdsenseCount'] <= 3) {

		/*
		**	지능적 광고 삽입 사용여부 체크
		**	by 카이 [w] http://kai.ibbun.net/
		*/
		if ($data['isArtificialAD'] === 'on') {

			//	글의 길이에 따른 광고 삽입 여부, 0 이면 글 길이를 제한하지 않음
			if (($data['articleLength'] === 0) ||
				($data['articleLength'] > 0 && (strlen(strip_tags(&$target)) >= $data['articleLength']))) {

				//	문장 분석
				$replaced = false;
				$max_offset = $max_length = $offset = 0;

				$split = preg_split('![<\[]('
							. str_replace(Array(',', ' '), Array('|', ''), $data['sentenceSplitTags'])
							.').*?[\]>].*?[<\[]/\1[\]>](?:<BR>|<P>|[\s\r\n])*!si',
							&$target, 6, PREG_SPLIT_OFFSET_CAPTURE);//	매칭을 6회로 제한
				foreach ($split as $key => $array) {
					$string =&$array[0];
					$offset =&$array[1];

					//	실제 문자수를 구합니다.
					//	- 테그를 제외, HTML 코드 복호, 한글(3바이트),알파벳,특수문자(1바이트)의 차이로 인한 문자열길이를 체크합니다.
					$sentence = htmlspecialchars_decode(strip_tags($string));
					preg_match_all('![\w\d\s\r\n\~\!#$%^&*()_\-=+\\"\',\.:;<>\[\]{}/]+!', &$sentence, $ascii);
					$ascii = strlen(implode('', &$ascii[0]));
					$length = strlen($string) + ($ascii * 2);

					//	문장의 길이와 환경설정에서 지정한 길이를 비교합니다.
					if ($length > $data['sentenceMinLength']) {
						$target = intelligenceAD_Insert(&$target, $offset, &$data['contentTopBox']);
						$replaced = true;
						break;

					//	가장 긴 문장의 길이를 체크 합니다.
					} elseif ($length > $max_length) {
						$max_length = $length;
						$max_offset = $offset;
					}
				}

				//	최적의 위치를 찾지 못했을 경우, 문장 길이에 상관없이 가장 긴 문장에 광고 삽입
				if ($replaced === false && $data['isAnalysisSentence'] === 'on') {
					$target = intelligenceAD_Insert(&$target, $max_offset, &$data['contentTopBox']);
				}

				$GLOBALS['_gGoogleAdsenseCount']++;
			}

		} else {
			//	지능적 광고 삽입 사용하지 않을때
			$contentTop.= $data['contentTopBox'];
			$GLOBALS['_gGoogleAdsenseCount']++;
		}
	}

	//	하단
	if (!empty($data['contentBottom']) && $GLOBALS['_gGoogleAdsenseCount'] <= 3) {
		$contentBottom = '<div id="googleAdBottom" style="clear:both; position:relative; text-align:center;">'. $data['contentBottom'] .'</div>';
		$GLOBALS['_gGoogleAdsenseCount']++;
	}

	return $contentTop . $target . $contentBottom;
}


function intelligenceAD_Insert(&$content, $offset, &$ad) {
	$ad = '<table width="100" height="100" align="right" border="0" cellpadding="0" cellspacing="0" style="position:relative; background-image:url(); background-repeat:no-repeat;"><tr><td valign="top" style="padding:0 0 5px 5px;">'. $ad .'</td></tr></table>';
	return substr_replace(&$content, &$ad, $offset, 0);
}


function takeoneGoogleAdsense_DataSet($data){
//	requireComponent('Tattertools.Function.misc');
//	$cfg = misc::fetchConfigVal($data);
	return true;
}


/*	function htmlspecialchars_decode(string string [, int quote_style])
**	by Wout (PHP.net)
**
**	- 이 함수는 PHP 5.1.0 이상에서 사용 가능합니다. PHP 5 이하의 버전에서도 지원하기 위한 유저함수 입니다.
**	- &lt; &gt; 와 같은 코드를 원래 코드로 변경합니다.
*/
if (!function_exists("htmlspecialchars_decode")) {
   function htmlspecialchars_decode($string, $quote_style = ENT_COMPAT) {
       return strtr($string, array_flip(get_html_translation_table(HTML_SPECIALCHARS, $quote_style)));
   }
}

?>